#include <stdio.h>
#include <SWI-Prolog.h>

#define GRID_SIZE 9

/*
	This function can be used to consult a prolog source file
*/
void consultFile(const char *fileName){
	predicate_t p_consult = PL_predicate("consult", 1, "database");
	term_t t = PL_new_term_ref();
	PL_put_string_chars(t, fileName);
	PL_call_predicate(NULL, 0, p_consult, t);
}

/*
	This function receives the sudoku input as a char matrix
	and constructs a list of lists from it (each row is a list)
*/
void create_grid(term_t lst, char rows[][GRID_SIZE+2]){
	//TODO: fill this function
	//rows is a matrix of chars
	//if rows[4][2]=='7', the 3rd element of the 5th list should be 7
	//if rows[1][8]=='_', the 9th element of the 2nd list should be 
	//a variable that the Prolog engine will unify with the correct digit
}

/*
	This functions receives the sudoku solution as a list of lists
	and prints it on the screen.
*/
void show_grid(term_t lst){
	//TODO: fill this function
	//Each inner list will be a row of the sudoku grid, where the free
	//variables have been unified with the correct digit.
}

void solve(const char *fileName){
	//read the sudoku grid
	FILE *f;
	fopen_s(&f, fileName, "r");
	char rows[GRID_SIZE][GRID_SIZE+2];
	int i;
	for(i=0; i<GRID_SIZE; ++i){
		fgets(rows[i], 11, f);
	}
	
	//prepare the sudoku predicate
	predicate_t p_sudoku = PL_predicate("sudoku", 1, "database");
	term_t t = PL_new_term_ref();
	create_grid(t, rows); //TODO: implement this function
	qid_t query = PL_open_query(NULL, PL_Q_NORMAL, p_sudoku, t);
	int result = PL_next_solution(query);
	if(result){
		printf("Solution found:\n");
		show_grid(t); //TODO: implement this function
		printf("\n");
	}else{
		printf("sudoku query failed!\n");
	}
	PL_close_query(query);
}

int main(int argc, char **argv){
	PL_initialise(argc, argv);
	consultFile("sudoku.pl");
	solve("problem1.txt");
	return 0;
}
